# storage-rules

This repository holds implementations of the Detect component of the Trust Monitoring Unit (TMU) that can be included in the experimental firmware build by [modular-firmware-suite](https://gitlab.ub.uni-bielefeld.de/ks-nano/modular-firmware-suite/-/tree/whitelist?ref_type=heads). For now this only entails a whitelist approach for which the rules are generated half-automatically by the following pipeline:

![Diagram of pipeline of git repositories.](https://gitlab.ub.uni-bielefeld.de/ks-nano/modular-firmware-suite/-/raw/whitelist/graphics/pipeline.svg?ref_type=heads)

This pipeline implements an environment to run firmware experiments on a FPGA that emulates a given System (currently only the AIRISC Core Complex). All information concerning the other repositories can be taken from their READMEs respectively.

**Table of Contents**

[[_TOC_]]

## Structure

The repository has the following general structure:
```bash
storage-rules
├── .ci_commit_changes.sh
└── SoCs
    └── SoC configurations
        └── firmware configurations
            ├── detector headers to be included in modular-firmware-suite
            └── detector rulesets
                └── headers holding specific rulesets for the detector headers
```
The idea is that on the first layer there are directories for each System-on-Chip (SoC) in use. In each of these directories are subdirectories for different configurations of the respective SoC. Each of these configurations can then also have different firmware configurations for which the detector implementations and their rulesets are bundled in directories.

Currently only the AIRISC is in use with a configuration of 32mhz and the firmware configuration given by the modular-firmware-suite (mfs-hil == **m**odular-**f**irmware-**s**uite-**h**ardware-**i**n-the-**l**oop). For now the only implemented Detect component is a whitelist approach (see [README.md of storage-report](https://gitlab.ub.uni-bielefeld.de/ks-nano/tmu/ecosystem/storage-report/-/tree/dev-hheile?ref_type=heads#notebooks-for-whitelist-approach)).

## How to Use

### Adding Rules
The static part of a detector (`whitelist_detector.h`) goes into the respective folder with the firmware configuration of the used SoC and it's configuration. The dynamic parts of a detector (rulesets like those in the folder *whitelist-header*) are collected into a subdirectory in the same folder. The latter are only used by the respective detector header itself, generated by notebooks in the repository [storage-report](https://gitlab.ub.uni-bielefeld.de/ks-nano/tmu/ecosystem/storage-report/-/tree/dev-hheile?ref_type=heads) and pushed into this repository via storage-report's CI. To make ensure that job doesn't fail, there is the shell script `.ci_commit_changes.sh` which is called by the CI script and only commits the changes if there are any. This way a failing commit cannot abort the job.

### Using Rules
The repository [modular-firmware-suite](https://gitlab.ub.uni-bielefeld.de/ks-nano/modular-firmware-suite/-/tree/whitelist?ref_type=heads) includes this repository as submodule so the contained detector headers can be included in the experimental firmware (see [README.md of modular-firmware-suite](https://gitlab.ub.uni-bielefeld.de/ks-nano/modular-firmware-suite/-/tree/whitelist?ref_type=heads#including-a-detect-component)).

